// Output generated from file: D:/frag/gr_refl_issue.bmp Files/gr_refl_issue.bmp Files/gr_refl_issue.frag
// Created:  20.  14:08:05 2017
// Output generated from file: D:/WideInFocusRenderer/new-CR10/PseudoKleinian03.frag
// Created:  18.  19:39:28 2017
#infoTheli-at's Pseudo Kleinian (Scale 1 JuliaBox + Something
#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#define MULTI_SAMPLE_AO
#include "DE-Kn2_grRefl.frag"
#include "MathUtils.frag"
#group PseudoKleinian

#define USE_INF_NORM



// Made by Knighty, see this thread:
// http://www.fractalforums.com/3d-fractal-generation/fragmentarium-an-ide-for-exploring-3d-fractals-and-other-systems-on-the-gpu/msg32270/#msg32270

// Maximum iterations
uniform int MI; slider[0,5,20]

// Bailout
//uniform float Bailout; slider[0,20,1000]

// Size
uniform float Size; slider[0,1,2]

// Cubic fold Size
uniform vec3 CSize; slider[(0,0,0),(1,1,1),(2,2,2)]

// Julia constant
uniform vec3 C; slider[(-2,-2,-2),(0,0,0),(2,2,2)]

// Thingy thickness
uniform float TThickness; slider[0,0.01,2]

// Thingy thickness2
uniform float TThickness2; slider[0,0.01,2]

// Thingy DE Offset
uniform float DEoffset; slider[0,0,0.01]

// Thingy Translation
uniform vec3 Offset; slider[(-1,-1,-1),(0,0,0),(1,1,1)]

float RoundBox(vec3 p, vec3 csize, float offset)
{
	vec3 di = abs(p) - csize;
	float k=max(di.x,max(di.y,di.z));
	return abs(k*float(k<0.)+ length(max(di,0.0))-offset);
}

float Thingy(vec3 p, float e){
	p-=Offset;
	float rxy=(length(p.xy)-TThickness2);
	return max(rxy, (abs(length(p.xy)*p.z)-e) / sqrt(dot(p,p)+abs(e)));
}

float Thing2(vec3 p){
//Just scale=1 Julia box
	float DEfactor=1.;
   	vec3 ap=p+1.;
	for(int i=0;i<MI && ap!=p;i++){
		ap=p;
		p=2.*clamp(p, -CSize, CSize)-p;
      
		float r2=dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p,r2)));
		float k=max(Size/r2,1.);

		p*=k;DEfactor*=k;
      
		p+=C;
		//orbitTrap = min(orbitTrap, abs(vec4(p,dot(p,p))));
	}
	//Call basic shape and scale its DE
	return abs(0.5*Thingy(p,TThickness)/DEfactor-DEoffset);
	
	//Alternative shape
	//return abs(0.5*RoundBox(p, vec3(1.,1.,1.), 1.0)/DEfactor-DEoffset);
	//Just a plane
	//return abs(0.5*abs(p.z-Offset.z)/DEfactor-DEoffset);
}

float DE(vec3 p){
	return  Thing2(p);//RoundBox(p, CSize, Offset);
}


































#preset default
FOV = 0.9
Eye = 0.327869,-2.25881,0.516615
Target = 10.4404,-2.90243,-0.171494
Up = 0,0,1
FocalPlane = 0.304445
Aperture = 0
InFocusAWidth = 0.5
ApertureNbrSides = 2 NotLocked
ApertureRot = 10
ApStarShaped = false NotLocked
Gamma = 2
ToneMapping = 5
Exposure = 2
Brightness = 1
Contrast = 1.1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 1.5
Bloom = false Locked
BloomIntensity = 0
BloomPow = 0.5618
BloomTaps = 5
Detail = -3
RefineSteps = 3
FudgeFactor = 1
MaxRaySteps = 800
MaxDistance = 10
Dither = 0.7
NormalBackStep = 0
DetailAO = -1
coneApertureAO = 0.90476
maxIterAO = 20
FudgeAO = 0.690909
AO_ambient = 1
AO_camlight = 0
AO_pointlight = 0
AoCorrect = 0
Specular = 0
SpecularExp = 1
CamLight = 0.733333,0.941176,1,0
AmbiantLight = 0.741176,0.843137,1,0
Glow = 1,1,1,0
GlowMax = 0
Reflection = 1,1,1
ReflectionsNumber = 1
SpotGlow = false
SpotLight = 1,0.615686,0.298039,3
LightPos = 1.8746,-2.5574,1.9626
LightSize = 0
LightFallOff = 1.21368
LightGlowRad = 0
LightGlowExp = 1.03895
HardShadow = 1 Locked
ShadowSoft = 0
BaseColor = 1,1,1
OrbitStrength = 0.756598
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.75
BackgroundColor = 0,0,0
GradientBackground = 0
CycleColors = true
Cycles = 3.49405
EnableFloor = true
FloorNormal = 0,0,-1
FloorHeight = -0.3442
FloorColor = 0.156863,0.243137,0.262745
HF_Fallof = 0.11111
HF_Const = 0.08333
HF_Intensity = 0
HF_Dir = 0,0,-1
HF_Offset = -0.190114
HF_Color = 0.262745,0.560784,0.721569,0.89553
HF_Scatter = 6
HF_Anisotropy = 0,0,0
HF_FogIter = 6
HF_CastShadow = true
CloudScale = 1
CloudFlatness = 0
CloudTops = 1
CloudBase = -1
CloudDensity = 1
CloudRoughness = 1
CloudContrast = 1
CloudColor = 0.65,0.68,0.7
SunLightColor = 0.7,0.5,0.3
MI = 10
Size = 0.7541
CSize = 0.60466,0.8062,0.8062
C = 0,0,0
TThickness = 0
TThickness2 = 0.97718
DEoffset = 0
Offset = 0,0,0
#endpreset

